local type = type
local UIParent = UIParent

setfenv(1, Dock.FunctionEnviroment)

local checked
local function FindMovableAnchor(frame)
	for i=1, frame:GetNumPoints() do
		local _, anchor = frame:GetPoint(i)
		if Core:IsFrameValid(anchor) then
			return anchor
		elseif anchor and not checked[anchor] then
			checked[anchor] = true
			anchor = FindMovableAnchor(anchor)
			if anchor then
				return anchor
			end
		end
		
	end
end

function Core:IsFrameValid(frame)
	if type(frame) ~= "table" or type(frame[0]) ~= "userdata" or not frame.IsMovable then
		return false, "noframe"
	elseif self:IsFrameBlacklisted(frame) then
		return false, "blacklist"
	elseif frame:IsProtected() then
		return false, "protected"
	elseif not frame:IsMovable() then
		return false, "notmovable"
	elseif not frame:IsShown() then
		return false, "notshown"
	end
	return true
end

function Core:SendToDockBinding(num)
	if type(num) ~= "number" then
		return
	end
	local dock = self:GetDockFrame(self.db.profile["DockBinding"..num])
	if dock then
		local frame = _G.GetMouseFocus()
		if not frame then
			self:OnDockFail("noframe")
		else
			local valid, reason = self:IsFrameValid(frame)
			if valid then
				dock:SendToDock(frame, self.db.profile["DockBindingInstant"..num])
			else --try to find a suitable frame this frame is anchored to
				checked = {}
				local anchor = FindMovableAnchor(frame)
				checked = nil
				if anchor then
					dock:SendToDock(anchor, self.db.profile["DockBindingInstant"..num])
				else
					self:OnDockFail(reason, frame)
				end
			end
			
		end
	else
		self:OnDockFail("nodock")
	end
end