setfenv(1, Dock.FunctionEnviroment)

local Core = Core

local FrameInfo = FrameInfo
local AnimatingRestorations = AnimatingRestorations
local AnimatingDocks = AnimatingDocks
local SharedDockedFrames = SharedDockedFrames
_G.SDocks = SharedDockedFrames
do
	local function StartMoving(self)
		--remove the IsProtected check to allow unit frames and action bars to be docked, however, this will taint them and leave them unclickable
		--use at your own risk, totally unsupported
		if FrameInfo.IgnoreHook then
			return
		end
		if Core:IsFrameBlacklisted(self) then
			FrameInfo.LastReason = "blacklist"
		elseif self:IsProtected() then
			FrameInfo.LastReason = "protected"
		else
			FrameInfo.LastReason = nil
			if AnimatingRestorations[self] or AnimatingDocks[self] then
				AnimatingRestorations[self] = nil
				AnimatingDocks[self] = nil
				self:StopMovingOrSizing()
				self:SetScale(FrameInfo.Scale[self])
				return self:StartMoving()
			end
			if SharedDockedFrames[self] then --already docked
				SharedDockedFrames[self]:ReleaseFrame(self)
				self:StopMovingOrSizing()
				self:SetScale(FrameInfo.Scale[self])
				return self:StartMoving()
			end
			FrameInfo.MovingX, FrameInfo.MovingY = self:GetCenter()
		end
		FrameInfo.MovingFrame = self
	end
	local function StopMovingOrSizing(self)
		if FrameInfo.IgnoreHook then
			return
		end
		FrameInfo.MovingFrame = nil
	end
	do
		local function IterateFrames(_, frame) return _G.EnumerateFrames(frame) end
		for i, objectType in _G.ipairs{_G.UIParent, _G.ItemRefCloseButton, _G.DEFAULT_CHAT_FRAME, _G.Minimap} do --need all of the object types since they have different metatables
			local mt = _G.getmetatable(objectType).__index
			 --iterate all the current frames and check to see if they're using a prehooked reference
			 --if they're using a local reference somewhere there's not really anything we can do, the frame will simply not work
			for frame in IterateFrames do
				if frame:HasScript("OnDragStart") and frame:GetScript("OnDragStart") == mt.StartMoving then
					frame:HookScript("OnDragStart", StartMoving) 
				end
				if frame:HasScript("OnDragStop") and frame:GetScript("OnDragStop") == mt.StopMovingOrSizing  then
					frame:HookScript("OnDragStop", StopMovingOrSizing)
				end
				if frame:HasScript("OnMouseDown") and frame:GetScript("OnMouseDown") == mt.StartMoving then
					frame:HookScript("OnMouseDown", StartMoving) 
				end
				if frame:HasScript("OnMouseUp") and frame:GetScript("OnMouseUp") == mt.StopMovingOrSizing then
					frame:HookScript("OnMouseUp", StopMovingOrSizing)
				end
			end
			_G.hooksecurefunc(mt, "StartMoving", StartMoving)
			_G.hooksecurefunc(mt, "StopMovingOrSizing", StopMovingOrSizing)
		end
	end
end

_G.hooksecurefunc("CreateFrame", function(objectType, name, ...)
	if name then
		Core:ExecuteDockMethod("OnCreateFrame", objectType, name, ...)
	end
end)